<template>
  <div>
    <h1 class="mb-3">Let’s start with the basics.</h1>
    <p class="text-base mb-6">This information helps your doctor determine if you’re eligible for treatment.</p>
    <div class="grid gap-y-3 mb-5">
      <div class="text-base flex items-center relative">
        <span class="mr-1">Sex Assigned at Birth</span>
        <img
          class="tooltip-target w-4 h-4 cursor-pointer"
          src="@/assets/img/icons/info.png"
          alt="info"
          @click="displayTooltip = !displayTooltip"
        >
        <transition name="fast-fade">
          <div
            class="z-10 top-full transform translate-y-2 absolute bg-green-sdark rounded-lg py-5 pl-5 pr-14 text-base text-white"
            v-if="displayTooltip"
          >
            <span class="font-medium">Your sex assigned at birth is needed by your doctor for making medical decisions.</span>
            <div
              class="w-4 h-4 absolute right-5 top-5 cursor-pointer flex items-center justify-center"
              @click="displayTooltip = false"
            >
              <CloseIcon
                bg-color="bg-white"
              />
            </div>
          </div>
        </transition>
      </div>
      <two-side-input
        first-value="Male"
        second-value="Female"
        v-model="selected.gender"
        :error-message="getErrorMessage('gender')"
      />
      <text-input
        placeholder="MM/DD/YYYY"
        label="Birthdate"
        v-model="selected.birthdate"
        :error-message="getErrorMessage('birthdate')"
      />
      <text-input
        label="Zipcode"
        v-model="selected.zipcode"
        :error-message="getErrorMessage('zipcode')"
      />
      <text-input
        label="Mobile Phone Number"
        v-model="selected.phone"
        :error-message="getErrorMessage('phone')"
      />
    </div>
    <checkbox-input
      class="mb-7"
      :transparent="true"
      :value="checkboxSelected"
      :input-value="true"
      @input="handleCheckboxInput"
      :error-message="!checkboxSelected.length && $v.$dirty ? 'Please fill this field' : null"
    >
        <span>
          I agree to the <a class="underline underline-green" href="#">terms</a>, <a class="underline underline-green" href="#">privacy policy</a> and consent to <a
          class="underline underline-green" href="#">telehealth</a>
        </span>
    </checkbox-input>
    <common-btn
      @click="handleClick"
      text="Next"
    />
  </div>
</template>

<script>
import {answersMixin, checkboxMixin, referMixin} from "@/utils/mixins";
import {required} from 'vuelidate/lib/validators'
import CloseIcon from "@/components/icons/CloseIcon";

const dateRegex = /^\d{2}\/\d{2}\/\d{4}$/g

const dateValidator = value => {
  return Boolean(String(new Date(value)) !== 'Invalid Date' && String(value).match(dateRegex))
}

export default {
  components: {CloseIcon},
  mixins: [answersMixin, checkboxMixin, referMixin],
  name: "TheBasics1",
  watch: {
    selected: {
      handler(newVal) {
        this.setAnswer(this.answersKeys.THE_BASICS, newVal, 'stage_1')
      },
      deep: true
    }
  },
  validations: {
    selected: {
      gender: {required},
      birthdate: {required, dateValidator},
      zipcode: {required},
      phone: {required},
    },
    checkboxSelected: {required},
  },
  data() {
    return {
      selected: {
        gender: null,
        birthdate: '',
        zipcode: '',
        phone: '',
      },
      checkHandler: () => {
        const value = this.checkboxSelected.length ? this.checkboxSelected[0] : null
        this.setAnswer(this.answersKeys.THE_BASICS, value, 'termsAgree')
      },
      displayTooltip: false,
    }
  },
  methods: {
    handleClick() {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        this.checkForRefer()
      }
    },
    checkForRefer() {
      const fullYears = new Date().getFullYear() - new Date(this.selected.birthdate).getFullYear()
      if (fullYears < 18) {
        this.setRefer('We’ve hit a minor road bump.', 'It appears you are too young to qualify for a prescription solution.\n\nFortunately, you may benefit from a different formula:')

      } else if (fullYears > 65) {
        this.setRefer('We’ve hit a minor road bump.', 'It appears you are too old to qualify for a prescription solution.\n\nFortunately, you may benefit from a different formula:')

      } else if (this.selected.gender === 'Male') {
        this.setRefer('We’ve hit a minor road bump.', 'It looks like a women’s personalized prescription is incompatible with your needs. These custom formulas work best for individuals assigned female at birth.\n\nSee if the men’s formula is right for you.')
      }

      if (this.refer) return

      this.$emit('nextStage')
    },
    getErrorMessage(field) {
      let msg = null
      const isInvalid = this.$v.selected[field].$invalid && this.$v.selected[field].$dirty

      if (isInvalid) {
        msg = 'Please fill this field'

        if (field === 'gender') {
          msg = 'Please select gender'
        }



        if (field === 'birthdate' && !this.$v.selected[field].dateValidator) {
          msg = 'Enter valid date'
        }
      }


      return msg
    }
  }
}
</script>

<style scoped>
.underline-green {
  text-decoration-color: #7FE4CF;
}
</style>
